//------------------------------------------------------------------------------
/*
    This file is part of Bottle2D.

    Bottle2D is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Bottle2D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Bottle2D.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#include "MyException.hpp"
#include "Global.hpp"
#include "lua.hpp"
#include <iostream>
//------------------------------------------------------------------------------
namespace En
{
//------------------------------------------------------------------------------
MyException::MyException(const std::string& info) throw() : m_info(info)
{
    //std::cerr << info << std::endl;
}
//------------------------------------------------------------------------------
MyException::~MyException() throw()
{

}
//------------------------------------------------------------------------------
const char* MyException::what() const throw()
{
    return m_info.c_str();
}
//------------------------------------------------------------------------------

void luaErrAddFileAndLine()
{
    lua_State *L = Global::GetLuaState();

    lua_Debug d;
    lua_getstack(L, 1, &d);
    lua_getinfo(L, "Sln", &d);
    std::string err = lua_tostring(L, -1);
    lua_pop(L, 1);
    std::stringstream msg;
    msg << d.short_src << ":" << d.currentline;

    if (d.name != 0)
    {
        msg << "(" << d.namewhat << " " << d.name << ")";
    }
    msg << " " << err;
    lua_pushstring(L, msg.str().c_str());
}

//------------------------------------------------------------------------------
} // namespace En
//------------------------------------------------------------------------------
