//------------------------------------------------------------------------------
/*
    This file is part of Bottle2D.

    Bottle2D is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Bottle2D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Bottle2D.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#include "ProtectedPtr.hpp"
//------------------------------------------------------------------------------
ProtectedClassBase::ProtectedClassBase()
{
    m_ptrInfo = new ptrInfo();
    m_ptrInfo->ptr = this;
    m_ptrInfo->refCount = 1;
}
//------------------------------------------------------------------------------
ProtectedClassBase::ProtectedClassBase(const ProtectedClassBase &src)
{
    m_ptrInfo = new ptrInfo();
    m_ptrInfo->ptr = this;
    m_ptrInfo->refCount = 1;
}
//------------------------------------------------------------------------------
ProtectedClassBase::~ProtectedClassBase()
{
    if(m_ptrInfo->refCount == 1) // Only the object itself left
    {
        delete m_ptrInfo;
    }
    else // Pointer on this object remains
    {
        m_ptrInfo->refCount--;
        m_ptrInfo->ptr = NULL;
    }
}
//------------------------------------------------------------------------------
ptrInfo *ProtectedClassBase::GetPtrInfo()
{
    return m_ptrInfo;
}
//------------------------------------------------------------------------------
bool ProtectedClassBase::HaveReferencedPtr() const
{
    return (m_ptrInfo->refCount != 1);
}
//------------------------------------------------------------------------------
